{*******************************************************}
{                                                       }
{       Turbo Pascal                                    }
{       Borland Custom Control Interface Unit           }
{                                                       }
{       Copyright (c) 1991 Borland International        }
{                                                       }
{*******************************************************}

unit BWCC;

interface
uses WinTypes;

function DialogBox(Instance: THandle; Templatename: PChar;
  WndParent: HWnd; DialogFunc: TFarProc): Integer;
function DialogBoxParam(Instance: THandle; TemplateName: PChar;
  WndParent: HWnd; DialogFunc: TFarProc; InitParam: LongInt): Integer;
function CreateDialog(Instance: THandle; TemplateName: PChar;
  WndParent: HWnd; DialogFunc: TFarProc): HWnd;
function CreateDialogParam(Instance: THandle; TemplateName: PChar;
  WndParent: HWnd; DialogFunc: TFarProc; InitParam: LongInt): HWnd;
function BWCCMessageBox(WndParent: HWnd; Txt, Caption: PChar;
  TextType: Word): Integer;
function BWCCDefDlgProc(Dlg: HWnd; Msg, wParam: Word; lParam: LongInt): LongInt;
function BWCCGetPattern: HBrush;
function BWCCGetVersion: Word;
function SpecialLoadDialog( hResMod: THandle; Templatename: PChar; DialogFunc: TFarProc): THandle;
function MangleDialog( hDlg: THandle; hResMod: THandle; DialogFunc: TFarProc): THandle;

const
  BwccVersion	= $0100;

  BorDlgClass = 'BorDlg';	{ Our Custom Dialog class }
  BorDlgProp  =	'FB';		{
  				  Borland dialog window uses
  				  this property for instance data
				  users should not use a property
				  with this name!
                                }

  IdHelp      =		998;     { Id of help button }

{
   button style definitions:

   the Borland buttons use Windows button styles for button
   type: i.e. BS_PUSHBUTTON/BS_DEFPUSHBUTTON
}

  Button_Class ='BorBtn';	{ Our Bitmap Buttons }
  Radio_Class  ='BorRadio';     { Our radio buttons }
  Check_Class  ='BorCheck';	{ Our Checkboxes }

{ styles }

  bbs_Bitmap:Longint    =  $8000;      { this is a bitmap static }
  bbs_DlgPaint:Longint  =  $4000;      { used at runtime by dialog class }
  bbs_ParentNotify:Longint=$2000;      { Notify parent of TAB keys and focus }
  bbs_OwnerDraw:Longint =  $1000;     { let parent paint via wm_DrawItem }

{  messages }

  bbm_SetBits    =  ( BM_SETSTYLE + 10);

{ notifications }

  bbn_SetFocus   =  ( BN_DOUBLECLICKED + 10);
  bbn_SetFocusmouse=( BN_DOUBLECLICKED + 11);
  bbn_GotaTab    =  ( BN_DOUBLECLICKED + 12);
  bbn_GotaBTab   =  ( BN_DOUBLECLICKED + 13);

  Shade_Class = 'BorShade';

  bss_Group:Longint  =	1;	{  group box
  bss_Hdip:Longint   =	2;	{  horizontal border
  bss_Vdip:Longint   =	3;	{  hertical border
  bss_Hbump:Longint  =	4;	{  horizontal speed bump
  bss_Vbump:Longint  =	5;	{  vertical speed bump

  bss_DlgErase:Longint =  $8000;  {  Dialog Window erases for us }
  bss_DlgPaint:Longint =  $4000;  {  Dialog Window paints for us }

  Static_Class =   'BorStatic';	{  Our statics }

implementation
function SpecialLoadDialog;  		external 'BWCC' index 1;
function DialogBox;			external 'BWCC' index 2;
function DialogBoxParam;		external 'BWCC' index 3;
function CreateDialog;                  external 'BWCC' index 4;
function CreateDialogParam;             external 'BWCC' index 5;
function BWCCDefDlgProc;                external 'BWCC' index 6;
function BWCCMessageBox;                external 'BWCC' index 9;
function BWCCGetPattern;                external 'BWCC' index 10;
function BWCCGetVersion;                external 'BWCC' index 11;
function MangleDialog;                  external 'BWCC' index 12;


end.
